<?php

class Xml 
{
	private static $xmlResult;
	private static $subj;
	
	public static function get($subj, $table = null, $where = array()) {
		#exit($subj);
		self::$subj = $subj;
		$model = Def::$model['essence'][$subj];
		$file = Def::check_path($model['file']);
		if (!$where) $where = Def::$request['where'];
		$type = esse($model, 'type');
		if (!$table) $table = $model['table'];
		$xml = self::get_arr($file, '', $table);
		#echo "$file, $table";
		//if ($file == Def::$config['model_file']) $xml = $xml[$subj];
		if (!count($xml)) return false;
		#print_r($xml);
		if ($subj == 'fields') {
			$tmp = array();
			foreach ($xml as $arr) {
				$tmp += $arr;
				$tmp = array_values($tmp);
			}
			$xml = $tmp;
		}
		$xml = array_values($xml);
		#print_r($xml); 
		#print_r($where); exit(count($where));
		
		if (count($where)) { 
			$tmp = array();
			foreach ($xml as $num => $row) { 
				$flag = true;
				foreach ($where as $key => $value) {
					if (!isset($row[$key])) {print_r($row); exit($num . '.');}
					if ($row[$key] != $value) $flag = false;
				}
				if ($flag) $tmp[] = $row;
			}
			$xml = $tmp;
		}
		
		return $xml;
	}
	
	public static function get_arr($file = '', $string = '', $table = null) {
		$xml0 = self::get_resourse($file, $string);
		$xml = self::obj2arr($xml0);
		if (!is_array($xml)) print_r($xml0);// = array();
		#if ($table) print_r($xml);
		return ($table) ? self::normalize_xml ($xml, $table) : $xml;
	}
	
	private static function normalize_xml ($xml, $table) {
		if (!is_array($xml)) return $xml;
		$model = Def::$model;
		$new_xml = array();
		$tpl = $model['fields'][$table];
		
		if ($table == 'fields') {
			foreach ($xml as $table => $fields) {
				if (empty($fields) || !count($fields)) continue;
				$new_xml[$table] = array();
				foreach ($fields as $field => $props) {
					$new_xml[$table][$field] = self::normalize ($props, $tpl);
				}
			}
		}
		else {
			foreach ($xml as $key => $row) {
				$new_xml[$key] = self::normalize($row, $tpl);
			}
		}
		return $new_xml;
	}
	
	public static function normalize (&$arr, &$tpl) {
		$res = array();
		//print_r($arr);
		$fields = array_keys($tpl);
		foreach ($fields as $field) {
			$res[$field] = esse($arr, $field);
		}
		return $res;
	}
	
	public static function denormalize (&$arr) {
		$res = array();
		if (count($arr)) {
			foreach ($arr as $key => $value) {
				if (is_array($value)) $res[$key] = self::denormalize($value);
				else if (!empty($value)) $res[$key] = $value;
			}
		}
		return $res;
	}
	
	public static function obj2arr(&$obj) {
		$arr = (array) $obj;
		if (count($arr)) {
			foreach ($arr as &$item) {
				if (is_object($item)) {
					$item = self::obj2arr($item);
				}
			}
		}
		else $arr = '';
		return $arr;
	}
	
	public static function get_resourse($file = '', $string = '') {
		if ($file) $xml = (file_exists($file)) ? simplexml_load_file($file) : false;
		else if ($string) $xml = simplexml_load_string($string);
		else $xml = array(); //параллельно mysql
		
		return $xml;
	}
	
	private static function arr2xml($arr, &$xml){
		if ($arr instanceof SimpleXMLElement) {
			$xml = $arr;
			return;
		}
		foreach ($arr as $name => $value) {
			if (!is_object($value) && !is_array($value)) {
				$xml->$name = $value;
				
			} else {
				$xml->$name = null;
				self::arr2xml($value, $xml->$name);
			}
			
		}
	}
	
	public static function delete($arr) {
		$subj = $arr['subj'];
		self::$subj = $subj;
		$model = Def::$model['essence'][$subj];
		$f = Def::check_path($model['file']);
		$table = $model['table'];
		$xml_base = self::get_arr($f, '', $table);
		
		if ($f == Def::$config['model_file']) $xml =& $xml_base[$subj];
		else $xml =& $xml_base;
		
		$name = esse($arr, 'query', 'name');
		if (!$name) return '!$name';
		Def::$env['referer'] = preg_replace("/name\=[^&]*/", '', Def::$env['referer']);
		if ($subj == 'fields') {
			$table = esse($arr, 'query', 'table');
			if (!$table) return '!$table';
			if (esse($xml, $table, $name)) unset($xml[$table][$name]);
			if (empty($xml[$table]) || !count($xml[$table])) unset($xml[$table]);
		}
		else /*if ($subj == 'users')*/ { //$subj == 'essence'
			unset($xml[$name]);
		}
		
		self::write_asXML('root', $xml_base, $f);
		return 0;
	}
	
	public static function create_table($subj) {
		self::$subj = $subj;
		$model = Def::$model['essence'][$subj];
		$f = Def::check_path($model['file']);
		
		if (file_exists($f)) return 'file exists: ' . $f . '. Удалите его руками.';
		
		if (self::write_asXML('root', array(), $f)) return 0;
		else return 'some error on write in ' . $f;
	}
	
	public static function write($subj, $arr, $where) {
		self::$subj = $subj;
		/** В xml всегда жёстко есть name. Хотя по уму надо pk (в mysql точно надо) */
		$model = Def::$model['essence'][$subj];
		
		$f = Def::check_path($model['file']);
		$table = $model['table'];
		$xml_base = self::get_arr($f, '', $table);
		#print_r($where); print_r($f);  print_r($xml_base); 
		
		if ($f == Def::$config['model_file']) $xml =& $xml_base[$subj];
		else $xml =& $xml_base;
		
		$root = 'root'; 
		$where_name = esse($where, 'name');
		#if (!$where_name) return '!$where_name';
		$set_name = esse($arr, 'name');
		if (!$set_name) {
			$set_name = $where_name;
			$new = false;
		}
		else $new = true;
		Def::$env['referer'] = preg_replace("/name\=([^&]*)/", 
			'name=' . $set_name, Def::$env['referer']);
		if ($subj == 'fields') {
			$table = esse($where, 'table');
			if (!$table) return '!$table';
			$pos =& $xml[$table];
			$row = (esse($xml, $table, $where_name)) ? $xml[$table][$where_name] : array();
		} else {
			$pos =& $xml;
			$row = (esse($xml, $where_name)) ? $xml[$where_name] : array();
		}
		
		foreach ($arr as $key => $value) {
			$row[$key] = $value;
		}
		
		$pos[$set_name] = $row;
		#print_r($row); print_r($pos); exit;
		$ok = self::write_asXML($root, $xml_base, $f); 
		return ($ok === true) ? 0 : ('some error on write asXML in ' . $f . ': <br><br>' . $ok);
	}
	
	public static function write_asXML($root, $arr, $path = null) {
		self::$xmlResult = new SimpleXMLElement("<$root></$root>");
		if ($arr && count($arr)) self::arr2xml($arr, self::$xmlResult);
		if ($path) {
			try {return self::$xmlResult->asXML($path);}
			catch(Exception $e) {return $e->getMessage();}
		}
		else return self::$xmlResult->asXML();
	}
		
}

