<?php

class Controller {

	public function __construct() {
		
		$this->set_request();
		$model = Def::$model['essence'];
		$subj = Def::$request['subj'];//view subj!!
		$site = Def::$request['site'];
		if (!isset($model[$subj])) exit(Def::e_404($subj));
		$essence = $model[$subj];
		$key_source = $_GET;
		
		$action = null;
		if (Def::$request['ext'] == 'com') {
			$this->check_auth(true);
			$action = esse($model[$subj], 'action');
			$class = esse($model[$subj], 'type'); //вообще-то type m.b. xml, mysql... это кросс-юзинг!
			
			$subj_work = esse($_POST, 'essence');//work subj!!
			if (!$subj_work) $subj_work = esse($_GET, 'essence');//work subj for "delete"??
			
			if (isset($_POST['where'])) $key_source = $_POST['where'];
			
		}
		else $subj_work = $subj;
		#exit($subj_work);
		if ($subj_work) {
			/**delete.com определяет ключи по рефереру*/
			$res = Def::get_key ($subj_work, $key_source);
			Def::$request['where'] = $res['where'];
			Def::$request['full_key'] = $res['full_key'];
		}
		#exit("$class::$action $subj");
		if (!is_null($action)) {
			if ($action) {
				if (!$class) $class = 'View';
				if ('self' == $class) self::$action($subj_work);
				else $class::$action($subj_work);
				
			}
			else exit(Def::e_404('!POST[com-action]'));
		}
		else {
			if ($site == 'data' || $site == 'constructor') $this->check_auth();
			new View();
		}
		
	}
	
	private static function auth($essence) {
		if (!session_id()) session_start();
		if (isset($_SESSION['user']) && !isset($_POST['where'])) session_destroy();
		else {
			$model = Def::$model['essence'][$essence];
			$table = $model['table'];
			$fields = Def::$model['fields'][$table];
			Data::normalize_values($_POST, $fields);
			$data = Data::get($essence, $_POST['where']);
			$data = $data['data'];
			if (count($data) == 1) {
				reset($data);
				$user = each($data);
				$user = $user['value'];
			#print_r($user);
				$_SESSION['user'] = $user;
			}
		}#print_r($_SESSION['user']); 
		header('Location: ' . Def::$env['referer']);
		
	}
	
	private function check_auth($quiet = false) {
		session_start(); //!! не всегда
		if (isset($_SESSION['user'])) Def::$user = $_SESSION['user'];
		else if (!$quiet) {
			Def::$request['where'] = array();
			new View('users', 'auth_form');
			exit;
		}
		
		//header('Location: ' . Def::$config['login']);
	}
	
	private function set_request() {
		
		Def::parse_query();
		
		$site = Def::$request['site'];
		if (!array_key_exists($site, Def::$model['sites'])) {exit(Def::e_404('!path'));}
		$site = Def::$model['sites'][$site];
		if (!empty($site['js'])) Def::$response['js'] += array($site['js'] => null);
		
	}
	
}