<?php

error_reporting(E_ALL);
ini_set('display_errors', true);
setlocale(LC_ALL, 'ru_RU.cp1251');
date_default_timezone_set('Asia/Yakutsk');

define('CR', "\n");
define('SITE', dirname(__FILE__));
define('LIB', SITE . '/../lib');

function corr() { 
	$model = Xml::get_arr(LIB . '/model.xml');
	$model['sites'] = array(
		'constructor' => array('path' => 'constructor', 'action' => 'build_constructor_menu'),
		'edit' => array(),
	);
	Xml::write('model', $model, LIB . '/model.xml');
	//Xml::write('model', $model, LIB . '/model0.xml');
	print_r($model);
}

new Def();
#corr();
new Controller();

function __autoload($class) 
{
	if (!defined('LIB')) return '!lib';
	$file = LIB . '/' . $class . '.php';
	if (file_exists($file)) require_once $file;
}

function esse(&$array)
{
/** Возвращает пустую, полную строку или массив */
	$args = func_get_args();
	$arr = array_shift($args);
	
	foreach($args as $key) 
	{
		if (is_null($key)) break;
	//Если у не-массива запрошен ключ - вернуть пустое!!
		$arr = (is_array($arr) && array_key_exists($key, $arr)) 
			? $arr[$key] 
			: null;
		if (is_null($arr)) break;
	}
	
	return (is_null($arr)) ? '' : $arr;
}

function def_e($x) {
	$in = array('"', "'", '<');
	$out = array('&#34;', "&#39;", '&lt ;');
	return str_replace($in, $out, $x);
}

function get_file_arr($path) {
	$file = array();
	if (!file_exists($path)) return $file;
	$file['time'] = filemtime($path);
	$file['text'] = implode(file($path));
	return($file);
}

function setContentLength($x) {
	header("Content-Length: ".strlen($x));
	return $x;
}



